scala.tools.nsc.typechecker.MethodSynthesis.MethodSynth

# LazyValGetter

###
Related Doc: package MethodSynth

#### case class LazyValGetter(tree: Global.ValDef) extends Namers.Namer.BaseGetter with Product with Serializable

Implements lazy value accessors:

- for lazy values of type Unit and all lazy fields inside traits, the rhs is the initializer itself
- for all other lazy values z the accessor is a block of this form: { z = <rhs>; z } where z can be an identifier or a field.

Source
  MethodSynthesis.scala

Linear Supertypes
Serializable, java.io.Serializable, Product, Equals, Namers.Namer.BaseGetter, Namers.Namer.DerivedGetter, Namers.Namer.DerivedFromValDef, Namers.Namer.DerivedFromMemberDef, Namers.Namer.Derived, AnyRef, Any
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. LazyValGetter
2. Serializable
3. Serializable
4. Product
5. Equals
6. BaseGetter
7. DerivedGetter
8. DerivedFromValDef
9. DerivedFromMemberDef
10. Derived
11. AnyRef
12. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Instance Constructors

1. #### new LazyValGetter(tree: Global.ValDef)

### Type Members

1. #### class ChangeOwnerAndModuleClassTraverser extends Global.ChangeOwnerTraverser

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from Namers.Namer.LazyValGetter to any2stringadd[Namers.Namer.LazyValGetter] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (Namers.Namer.LazyValGetter, B)

   Implicit information
     This member is added by an implicit conversion from Namers.Namer.LazyValGetter to ArrowAssoc[Namers.Namer.LazyValGetter] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   arg0

     the object to compare against this object for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

6. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

7. #### final def basisSym: Global.Symbol

   Definition Classes
     DerivedFromMemberDef

8. #### def category: Global.ClassSymbol

   Which meta-annotation is associated with this kind of entity.

   Which meta-annotation is associated with this kind of entity. Presently one of: field, getter, setter, beanGetter, beanSetter, param.

   Definition Classes
     BaseGetter → DerivedFromValDef

9. #### def clone(): AnyRef

   Create a copy of the receiver object.

   Create a copy of the receiver object.

   The default implementation of the `clone` method is platform dependent.

   returns

     a copy of the receiver object.

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )
   Note

     not specified by SLS as a member of AnyRef

10. #### final def completer(sym: Global.Symbol): Analyzer.TypeCompleter with Analyzer.LockingTypeCompleter with Global.FlagAgnosticCompleter

    type completer for the synthetic member.

    type completer for the synthetic member.

    Definition Classes
      DerivedFromValDef → Derived

11. #### def createAndEnterSymbol(): Global.Symbol

    Definition Classes
      DerivedFromValDef

12. #### final def derive(initial: List[Global.AnnotationInfo]): Global.Tree

    Definition Classes
      DerivedFromValDef

13. #### final def derivedMods: Global.Modifiers

    Definition Classes
      DerivedFromValDef

14. #### def derivedSym: Global.Symbol

    The derived symbol.

    The derived symbol. It is assumed that this symbol already exists and has been entered in the parent scope when derivedSym is called

    Definition Classes
      LazyValGetter → DerivedFromValDef → Derived

15. #### def derivedTree: Global.DefDef

    The definition tree of the derived symbol.

    The definition tree of the derived symbol.

    Definition Classes
      LazyValGetter → DerivedFromValDef → Derived

16. #### final def enclClass: Global.Symbol

    Definition Classes
      DerivedFromValDef → DerivedFromMemberDef

17. #### def ensuring(cond: (Namers.Namer.LazyValGetter) ⇒ Boolean, msg: ⇒ Any): Namers.Namer.LazyValGetter

    Implicit information
      This member is added by an implicit conversion from Namers.Namer.LazyValGetter to Ensuring[Namers.Namer.LazyValGetter] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

18. #### def ensuring(cond: (Namers.Namer.LazyValGetter) ⇒ Boolean): Namers.Namer.LazyValGetter

    Implicit information
      This member is added by an implicit conversion from Namers.Namer.LazyValGetter to Ensuring[Namers.Namer.LazyValGetter] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

19. #### def ensuring(cond: Boolean, msg: ⇒ Any): Namers.Namer.LazyValGetter

    Implicit information
      This member is added by an implicit conversion from Namers.Namer.LazyValGetter to Ensuring[Namers.Namer.LazyValGetter] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

20. #### def ensuring(cond: Boolean): Namers.Namer.LazyValGetter

    Implicit information
      This member is added by an implicit conversion from Namers.Namer.LazyValGetter to Ensuring[Namers.Namer.LazyValGetter] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

21. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

22. #### final def fieldSelection: Global.Select

    Definition Classes
      DerivedFromValDef

23. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

24. #### def flagsExtra: Long

    The flags that the derived symbol has in addition to those retained from the original symbol

    The flags that the derived symbol has in addition to those retained from the original symbol

    Definition Classes
      BaseGetter → Derived

25. #### def flagsMask: Long

    The flags that are retained from the original symbol

    The flags that are retained from the original symbol

    Definition Classes
      BaseGetter → Derived

26. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from Namers.Namer.LazyValGetter to StringFormat[Namers.Namer.LazyValGetter] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

27. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

28. #### def isDeferred: Boolean

    Definition Classes
      DerivedFromValDef

29. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

30. #### def isSetter: Boolean

    Definition Classes
      DerivedFromValDef

31. #### def keepClean: Boolean

    Definition Classes
      DerivedFromValDef

32. #### final def mods: Global.Modifiers

    Definition Classes
      DerivedFromMemberDef

33. #### def name: Global.TermName

    The name of the method

    The name of the method

    Definition Classes
      BaseGetter → Derived

34. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

35. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

36. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

37. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

38. #### val tree: Global.ValDef

    The tree from which we are deriving a synthetic member.

    The tree from which we are deriving a synthetic member. Typically, that's given as an argument of the instance.

    Definition Classes
      LazyValGetter → DerivedFromValDef → DerivedFromMemberDef → Derived

39. #### def validate(): Unit

    Definition Classes
      BaseGetter → DerivedFromValDef

40. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

41. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

42. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

43. #### def →[B](y: B): (Namers.Namer.LazyValGetter, B)

    Implicit information
      This member is added by an implicit conversion from Namers.Namer.LazyValGetter to ArrowAssoc[Namers.Namer.LazyValGetter] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from Serializable

### Inherited from java.io.Serializable

### Inherited from Product

### Inherited from Equals

### Inherited from Namers.Namer.BaseGetter

### Inherited from Namers.Namer.DerivedGetter

### Inherited from Namers.Namer.DerivedFromValDef

### Inherited from Namers.Namer.DerivedFromMemberDef

### Inherited from Namers.Namer.Derived

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from Namers.Namer.LazyValGetter to any2stringadd[Namers.Namer.LazyValGetter]

### Inherited by implicit conversion StringFormat from Namers.Namer.LazyValGetter to StringFormat[Namers.Namer.LazyValGetter]

### Inherited by implicit conversion Ensuring from Namers.Namer.LazyValGetter to Ensuring[Namers.Namer.LazyValGetter]

### Inherited by implicit conversion ArrowAssoc from Namers.Namer.LazyValGetter to ArrowAssoc[Namers.Namer.LazyValGetter]

### Ungrouped